asyncapi: 3.0.0
info:
    title: Rush Hour Aggregation
    version: 1.0.0
    description: This document describes internal RabbitMQ queues of the Rush Hour Aggregation module. The module is responsible for aggregating traffic data from various sources for the purposes of the project Praha dopravní.
    contact:
        name: Golemio Prague Data Plaform
        email: golemio@operatorict.cz
        url: https://golemio.cz
operations:
    rush-hour-aggregation.aggregateData:
        action: "send"
        channel:
            $ref: "#/channels/rush-hour-aggregation.aggregateData"
    rush-hour-aggregation.refreshHistoricViews:
        action: "send"
        channel:
            $ref: "#/channels/rush-hour-aggregation.refreshHistoricViews"
channels:
    rush-hour-aggregation.aggregateData:
        address: dataplatform.rush-hour-aggregation.aggregateData
        description: Aggregate traffic data of a given type from a given time period to database. If the given time period contains too much data, the task will be split into multiple subtasks. If no message is given, all types of data will be aggregated for time period of the last 10 minutes.
        bindings:
            amqp:
                is: queue
                queue:
                    durable: true
        messages:
            empty:
                $ref: "#/components/messages/emptyMessage"
            data:
                $ref: "#/components/messages/rush-hour-aggregation.aggregateData"
    rush-hour-aggregation.refreshHistoricViews:
        address: dataplatform.rush-hour-aggregation.refreshHistoricViews
        description: Refresh historic database material views for traffic data aggregations
        bindings:
            amqp:
                is: queue
                queue:
                    durable: true
        messages:
            empty:
                $ref: "#/components/messages/emptyMessage"
components:
    messages:
        emptyMessage:
            title: Empty message
        rush-hour-aggregation.aggregateData:
            payload:
                $ref: "#/components/schemas/rush-hour-aggregation.IAggregationTask"
    schemas:
        rush-hour-aggregation.IAggregationTask:
            type: object
            properties:
                type:
                    type: string
                    description: Type of data to be aggregated
                    enum:
                        - SDDR
                        - FCD
                        - NDIC
                        - WAZER
                        - WAZEJ
                from:
                    type: string
                    format: date-time
                    description: Start of the time period to be aggregated
                to:
                    type: string
                    format: date-time
                    description: End of the time period to be aggregated
                updateOnDuplicate:
                    type: boolean
                    description: If true, the aggregation will update existing records in the database. Defaults to `false`.
                refreshView:
                    type: boolean
                    description: If true, the traffic data materialized views will be refreshed after the aggregation. Defaults to `false`.
            required:
                - type
                - from
                - to
